unit Array5U;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, StdCtrls, Array5U2;

type
  TArray5MainForm = class(TForm)
    ListBox1: TListBox;
    btnResizeArray: TButton;
    btnFillArray: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnResizeArrayClick(Sender: TObject);
    procedure btnFillArrayClick(Sender: TObject);
  private
    MyArray: TIntegerArray;
    procedure DisplayArray;
  end;

var
  Array5MainForm: TArray5MainForm;

implementation

{$R *.DFM}

procedure TArray5MainForm.FormCreate(Sender: TObject);
begin
  MyArray := TIntegerArray.Create(
    StrToInt(InputBox(
      'Enter your array dimensions',
      'Number of elements:', '10')));
  btnFillArray.Click; { Pretend to push the array filling button }
  DisplayArray
end;

procedure TArray5MainForm.FormDestroy(Sender: TObject);
begin
  MyArray.Free
end;

procedure TArray5MainForm.btnResizeArrayClick(Sender: TObject);
begin
  MyArray.Size := StrToInt(InputBox(
    'Enter your new array dimensions',
    'Number of elements:', '20'));
  DisplayArray
end;

procedure TArray5MainForm.btnFillArrayClick(Sender: TObject);
var
  Loop: Integer;
begin
  for Loop := 0 to Pred(MyArray.Size) do
    MyArray[Loop] := Loop;
  DisplayArray
end;

procedure TArray5MainForm.DisplayArray;
var
  Loop: Integer;
begin
  with ListBox1, Items do
  begin
    BeginUpdate;
    try
      Clear;
      for Loop := 0 to Pred(MyArray.Size) do
        Add(IntToStr(MyArray[Loop]));
      ItemIndex := Pred(MyArray.Size)
    finally
      EndUpdate
    end
  end
end;

end.
 