unit Array5U2;

interface

uses
  Classes;

type
  TIntegerArray = class
  private
    FElements: TList;
    function GetElement(Index: Integer): Integer;
    procedure SetElement(Index: Integer; const Value: Integer);
    function GetSize: Integer;
    procedure SetSize(const Value: Integer);
  public
    constructor Create(ArraySize: Integer);
    destructor Destroy; override;
    property Element[Index: Integer]: Integer
      read GetElement write SetElement; default;
    property Size: Integer read GetSize write SetSize;
  end; { TIntegerArray }

implementation

{ TIntegerArray }

constructor TIntegerArray.Create(ArraySize: Integer);
begin
  inherited Create;
  FElements := TList.Create;
  FElements.Count := ArraySize
end;

destructor TIntegerArray.Destroy;
begin
  FElements.Free;
  FElements := nil;
  inherited Destroy
end;

function TIntegerArray.GetElement(Index: Integer): Integer;
begin
  Result := Integer(FElements[Index])
end;

function TIntegerArray.GetSize: Integer;
begin
  Result := FElements.Count
end;

procedure TIntegerArray.SetElement(Index: Integer; const Value: Integer);
begin
  FElements[Index] := Pointer(Value)
end;

procedure TIntegerArray.SetSize(const Value: Integer);
begin
  FElements.Count := Value
end;

end.
