unit Array6U2;

interface

uses
  Classes;

type
  TIntegerArray = class
  private
    FElements: TStrings;
    function GetElement(const Index: String): Integer;
    procedure SetElement(const Index: String; const Value: Integer);
  public
    constructor Create;
    destructor Destroy; override;
    property Element[const Index: String]: Integer
      read GetElement write SetElement; default;
    property List: TStrings read FElements;
  end; { TIntegerArray }

implementation

uses
  SysUtils;

constructor TIntegerArray.Create;
begin
  inherited Create;
  FElements := TStringList.Create;
end;

destructor TIntegerArray.Destroy;
begin
  FElements.Free;
  FElements := nil;
  inherited Destroy
end;

function TIntegerArray.GetElement(const Index: String): Integer;
var
  Value: String;
begin
  Value := FElements.Values[Index];
  if Value = '' then
    Result := 0
  else
    Result := StrToInt(Value)
end;

procedure TIntegerArray.SetElement(const Index: String; const Value: Integer);
begin
  FElements.Values[Index] := IntToStr(Value)
end;

end.
